## rapidfuzz 3.6.2+ds

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.12...3.24)

set(CMAKE_INTERPROCEDURAL_OPTIMIZATION TRUE)
set(CMAKE_POSITION_INDEPENDENT_CODE ON)
set(SKBUILD_LINK_LIBRARIES_KEYWORD PRIVATE)
set(THREADS_PREFER_PTHREAD_FLAG ON)

list(APPEND CMAKE_MODULE_PATH "${CMAKE_CURRENT_SOURCE_DIR}/cmake")

project(rapidfuzz LANGUAGES C CXX)

include(CMakePrintHelpers)
cmake_print_variables(CMAKE_AR CMAKE_C_COMPILER_AR CMAKE_CXX_COMPILER_AR)
cmake_print_variables(CMAKE_RANLIB CMAKE_C_COMPILER_RANLIB
                      CMAKE_CXX_COMPILER_RANLIB)

if("${CMAKE_C_COMPILER_AR}" STREQUAL "")
  set(CMAKE_C_COMPILER_AR "${CMAKE_AR}")
endif()
if("${CMAKE_CXX_COMPILER_AR}" STREQUAL "")
  set(CMAKE_CXX_COMPILER_AR "${CMAKE_AR}")
endif()
if("${CMAKE_C_COMPILER_RANLIB}" STREQUAL "")
  set(CMAKE_C_COMPILER_RANLIB "${CMAKE_RANLIB}")
endif()
if("${CMAKE_CXX_COMPILER_RANLIB}" STREQUAL "")
  set(CMAKE_CXX_COMPILER_RANLIB "${CMAKE_RANLIB}")
endif()

if(MSVC)
  add_compile_options(/W4 /bigobj /wd4127)
else()
  add_compile_options(-Wall -Wextra -pedantic -Wno-psabi)
endif()

if(CMAKE_VERSION VERSION_LESS 3.18)
  find_package(
    Python
    COMPONENTS Interpreter Development
    REQUIRED)
else()
  set(Python_ARTIFACTS_INTERACTIVE TRUE)
  find_package(
    Python
    COMPONENTS Interpreter Development.Module
    REQUIRED)
endif()

if(CMAKE_VERSION VERSION_LESS 3.17)
  execute_process(
    COMMAND
      "${Python_EXECUTABLE}" -c
      "import sysconfig; print(sysconfig.get_config_var('EXT_SUFFIX').split('.')[1])"
    OUTPUT_VARIABLE Python_SOABI
    OUTPUT_STRIP_TRAILING_WHITESPACE COMMAND_ECHO STDOUT)
  message(STATUS "Corrected SOABI: ${Python_SOABI}")
elseif("${Python_INTERPRETER_ID}" STREQUAL "PyPy")
  message(STATUS "PyPy SOABI: ${Python_SOABI}")
  execute_process(
    COMMAND
      "${Python_EXECUTABLE}" -c
      "import sysconfig; print(sysconfig.get_config_var('EXT_SUFFIX').split('.')[1])"
    OUTPUT_VARIABLE Python_SOABI
    OUTPUT_STRIP_TRAILING_WHITESPACE COMMAND_ECHO STDOUT)
  message(STATUS "Corrected SOABI: ${Python_SOABI}")
endif()

include(FetchContent)
include(CheckCPUArch)

check_cpu_arch_x64(RAPIDFUZZ_ARCH_X64)
check_cpu_arch_x86(RAPIDFUZZ_ARCH_X86)

set(RF_BASE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/src)

find_package(Taskflow 3.3.0 QUIET)
if(Taskflow_FOUND)
  message(STATUS "Using system supplied version of Taskflow")
else()
  message(STATUS "Using packaged version of Taskflow")
  set(TF_BUILD_CUDA
      OFF
      CACHE BOOL "Enables build of CUDA code")
  set(TF_BUILD_TESTS
      OFF
      CACHE BOOL "Enables build of tests")
  set(TF_BUILD_EXAMPLES
      OFF
      CACHE BOOL "Enables build of examples")
  add_subdirectory(extern/taskflow EXCLUDE_FROM_ALL)
  add_library(Taskflow::Taskflow ALIAS Taskflow)
endif()

find_package(rapidfuzz 3.0.2 QUIET)
if(rapidfuzz_FOUND)
  message(STATUS "Using system supplied version of rapidfuzz-cpp")
else()
  message(STATUS "Using packaged version of rapidfuzz-cpp")
  add_subdirectory(extern/rapidfuzz-cpp)
endif()

add_subdirectory(src/rapidfuzz)
add_subdirectory(src/rapidfuzz/distance)

=== src/rapidfuzz/CMakeLists.txt ===
function(create_cython_target _name)
  if(EXISTS ${CMAKE_CURRENT_LIST_DIR}/${_name}.cxx)
    set(${_name}
        ${CMAKE_CURRENT_LIST_DIR}/${_name}.cxx
        PARENT_SCOPE)
  else()
    find_package(Cython REQUIRED)
    # should use target_include_directories once this is supported by
    # scikit-build
    include_directories(${RF_BASE_DIR}/rapidfuzz)
    add_cython_target(${_name} CXX)
    set(${_name}
        ${_name}
        PARENT_SCOPE)
  endif()
endfunction(create_cython_target)

function(rf_add_library name)
  if(CMAKE_VERSION VERSION_LESS 3.17)
    python_add_library(${name} MODULE ${ARGV})
    get_property(
      suffix
      TARGET ${name}
      PROPERTY SUFFIX)
    if(NOT suffix)
      set(suffix "${CMAKE_SHARED_MODULE_SUFFIX}")
    endif()
    set_property(TARGET ${name} PROPERTY SUFFIX ".${Python_SOABI}${suffix}")
  else()
    python_add_library(${name} MODULE WITH_SOABI ${ARGV})
  endif()
endfunction(rf_add_library)

if(RAPIDFUZZ_ARCH_X64 OR RAPIDFUZZ_ARCH_X86)
  create_cython_target(_feature_detector_cpp)
  rf_add_library(_feature_detector_cpp ${_feature_detector_cpp}
                 ${CMAKE_CURRENT_LIST_DIR}/FeatureDetector/CpuInfo.cpp)
  target_compile_features(_feature_detector_cpp PUBLIC cxx_std_17)
  target_include_directories(_feature_detector_cpp
                             PRIVATE ${RF_BASE_DIR}/rapidfuzz)
  target_link_libraries(_feature_detector_cpp PRIVATE rapidfuzz::rapidfuzz)
  install(TARGETS _feature_detector_cpp LIBRARY DESTINATION src/rapidfuzz)
endif()

create_cython_target(utils_cpp)
rf_add_library(utils_cpp ${utils_cpp} ${CMAKE_CURRENT_LIST_DIR}/utils.cpp)
target_compile_features(utils_cpp PUBLIC cxx_std_17)
target_include_directories(utils_cpp PRIVATE ${RF_BASE_DIR}/rapidfuzz)
target_link_libraries(utils_cpp PRIVATE rapidfuzz::rapidfuzz)
install(TARGETS utils_cpp LIBRARY DESTINATION src/rapidfuzz)

create_cython_target(fuzz_cpp)
rf_add_library(fuzz_cpp ${fuzz_cpp})
target_compile_features(fuzz_cpp PUBLIC cxx_std_17)
target_include_directories(fuzz_cpp PRIVATE ${RF_BASE_DIR}/rapidfuzz)
target_link_libraries(fuzz_cpp PRIVATE rapidfuzz::rapidfuzz)
install(TARGETS fuzz_cpp LIBRARY DESTINATION src/rapidfuzz)

if(RAPIDFUZZ_ARCH_X64 OR RAPIDFUZZ_ARCH_X86)
  create_cython_target(fuzz_cpp_avx2)
  rf_add_library(fuzz_cpp_avx2 ${fuzz_cpp_avx2})
  target_compile_features(fuzz_cpp_avx2 PUBLIC cxx_std_17)

  if(MSVC)
    set_target_properties(fuzz_cpp_avx2 PROPERTIES COMPILE_FLAGS "/arch:AVX2")
  else()
    set_target_properties(fuzz_cpp_avx2 PROPERTIES COMPILE_FLAGS "-mavx2")
  endif()

  target_include_directories(fuzz_cpp_avx2 PRIVATE ${RF_BASE_DIR}/rapidfuzz)
  target_link_libraries(fuzz_cpp_avx2 PRIVATE rapidfuzz::rapidfuzz)
  install(TARGETS fuzz_cpp_avx2 LIBRARY DESTINATION src/rapidfuzz)
endif()

if(RAPIDFUZZ_ARCH_X86)
  create_cython_target(fuzz_cpp_sse2)
  rf_add_library(fuzz_cpp_sse2 ${fuzz_cpp_sse2})
  target_compile_features(fuzz_cpp_sse2 PUBLIC cxx_std_17)

  if(MSVC)
    set_target_properties(fuzz_cpp_sse2 PROPERTIES COMPILE_FLAGS "/arch:SSE2")
  else()
    set_target_properties(fuzz_cpp_sse2 PROPERTIES COMPILE_FLAGS "-msse2")
  endif()

  target_include_directories(fuzz_cpp_sse2 PRIVATE ${RF_BASE_DIR}/rapidfuzz)
  target_link_libraries(fuzz_cpp_sse2 PRIVATE rapidfuzz::rapidfuzz)
  install(TARGETS fuzz_cpp_sse2 LIBRARY DESTINATION src/rapidfuzz)
endif()

create_cython_target(process_cpp_impl)
rf_add_library(process_cpp_impl ${process_cpp_impl})
target_compile_features(process_cpp_impl PUBLIC cxx_std_17)
target_include_directories(process_cpp_impl PRIVATE ${RF_BASE_DIR}/rapidfuzz)
target_link_libraries(process_cpp_impl PRIVATE Taskflow::Taskflow
                                               rapidfuzz::rapidfuzz)

# check if we need to link with libatomic (not needed on Windows)
if(NOT Windows)
  # TODO: migrate to CheckSourceCompiles in CMake >= 3.19
  include(CheckCXXSourceCompiles)

  set(ATOMICS_TEST_SOURCE
      [=[
        #include <atomic>
        #include <cstdint>
        #include <cstddef>
        std::atomic<int> x{0};
        int main() {
            auto c = x.load(std::memory_order_relaxed);
            return 0;
        }
    ]=])
  string(REPLACE "std::atomic<int>" "std::atomic<std::size_t>"
                 ATOMICS_SIZE_T_TEST_SOURCE "${ATOMICS_TEST_SOURCE}")
  string(REPLACE "std::atomic<int>" "std::atomic<void*>"
                 ATOMICS_VOID_PTR_TEST_SOURCE "${ATOMICS_TEST_SOURCE}")
  string(REPLACE "std::atomic<int>" "std::atomic<unsigned>"
                 ATOMICS_UNSIGNED_TEST_SOURCE "${ATOMICS_TEST_SOURCE}")
  string(REPLACE "std::atomic<int>" "std::atomic<uint64_t>"
                 ATOMICS_UINT64_TEST_SOURCE "${ATOMICS_TEST_SOURCE}")

  if(APPLE)
    set(CMAKE_REQUIRED_FLAGS "-std=c++11")
  endif()
  check_cxx_source_compiles("${ATOMICS_TEST_SOURCE}"
                            HAVE_CXX_ATOMICS_INT_WITHOUT_LIB)
  check_cxx_source_compiles("${ATOMICS_SIZE_T_TEST_SOURCE}"
                            HAVE_CXX_ATOMICS_SIZE_T_WITHOUT_LIB)
  check_cxx_source_compiles("${ATOMICS_VOID_PTR_TEST_SOURCE}"
                            HAVE_CXX_ATOMICS_VOID_PTR_WITHOUT_LIB)
  check_cxx_source_compiles("${ATOMICS_UNSIGNED_TEST_SOURCE}"
                            HAVE_CXX_ATOMICS_UNSIGNED_WITHOUT_LIB)
  check_cxx_source_compiles("${ATOMICS_UINT64_TEST_SOURCE}"
                            HAVE_CXX_ATOMICS_UINT64_WITHOUT_LIB)
  if((NOT HAVE_CXX_ATOMICS_INT_WITHOUT_LIB)
     OR (NOT HAVE_CXX_ATOMICS_SIZE_T_WITHOUT_LIB)
     OR (NOT HAVE_CXX_ATOMICS_VOID_PTR_WITHOUT_LIB)
     OR (NOT HAVE_CXX_ATOMICS_UNSIGNED_WITHOUT_LIB)
     OR (NOT HAVE_CXX_ATOMICS_UINT64_WITHOUT_LIB))
    set(CMAKE_REQUIRED_LIBRARIES "atomic")
    check_cxx_source_compiles("${ATOMICS_TEST_SOURCE}"
                              HAVE_CXX_ATOMICS_INT_WITH_LIB)
    check_cxx_source_compiles("${ATOMICS_SIZE_T_TEST_SOURCE}"
                              HAVE_CXX_ATOMICS_SIZE_T_WITH_LIB)
    check_cxx_source_compiles("${ATOMICS_VOID_PTR_TEST_SOURCE}"
                              HAVE_CXX_ATOMICS_VOID_PTR_WITH_LIB)
    check_cxx_source_compiles("${ATOMICS_UNSIGNED_TEST_SOURCE}"
                              HAVE_CXX_ATOMICS_UNSIGNED_WITH_LIB)
    check_cxx_source_compiles("${ATOMICS_UINT64_TEST_SOURCE}"
                              HAVE_CXX_ATOMICS_UINT64_WITH_LIB)
    if(NOT HAVE_CXX_ATOMICS_INT_WITH_LIB)
      message(
        FATAL_ERROR
          "No native support for std::atomic<int>, or libatomic not found!")
    elseif(NOT HAVE_CXX_ATOMICS_SIZE_T_WITH_LIB)
      message(
        FATAL_ERROR
          "No native support for std::atomic<size_t>, or libatomic not found!")
    elseif(NOT HAVE_CXX_ATOMICS_VOID_PTR_WITH_LIB)
      message(
        FATAL_ERROR
          "No native support for std::atomic<void*>, or libatomic not found!")
    elseif(NOT HAVE_CXX_ATOMICS_UNSIGNED_WITH_LIB)
      message(
        FATAL_ERROR
          "No native support for std::atomic<unsigned>, or libatomic not found!"
      )
    elseif(NOT HAVE_CXX_ATOMICS_UINT64_WITH_LIB)
      message(
        FATAL_ERROR
          "No native support for std::atomic<uint64>, or libatomic not found!")
    else()
      message(STATUS "Linking with libatomic for atomics support")
      unset(CMAKE_REQUIRED_LIBRARIES)
      target_link_libraries(process_cpp_impl PUBLIC atomic)
    endif()
  endif()
  if(APPLE)
    unset(CMAKE_REQUIRED_FLAGS)
  endif()
endif()

install(TARGETS process_cpp_impl LIBRARY DESTINATION src/rapidfuzz)

=== src/rapidfuzz/distance/CMakeLists.txt ===
function(create_cython_target _name)
  if(EXISTS ${CMAKE_CURRENT_LIST_DIR}/${_name}.cxx)
    set(${_name}
        ${CMAKE_CURRENT_LIST_DIR}/${_name}.cxx
        PARENT_SCOPE)
  else()
    find_package(Cython REQUIRED)
    # should use target_include_directories once this is supported by
    # scikit-build
    include_directories(${RF_BASE_DIR}/rapidfuzz
                        ${RF_BASE_DIR}/rapidfuzz/distance)
    add_cython_target(${_name} CXX)
    set(${_name}
        ${_name}
        PARENT_SCOPE)
  endif()
endfunction(create_cython_target)

function(rf_add_library name)
  if(CMAKE_VERSION VERSION_LESS 3.17)
    python_add_library(${name} MODULE ${ARGV})
    get_property(
      suffix
      TARGET ${name}
      PROPERTY SUFFIX)
    if(NOT suffix)
      set(suffix "${CMAKE_SHARED_MODULE_SUFFIX}")
    endif()
    set_property(TARGET ${name} PROPERTY SUFFIX ".${Python_SOABI}${suffix}")
  else()
    python_add_library(${name} MODULE WITH_SOABI ${ARGV})
  endif()
endfunction(rf_add_library)

create_cython_target(_initialize_cpp)
rf_add_library(_initialize_cpp ${_initialize_cpp})
target_compile_features(_initialize_cpp PUBLIC cxx_std_17)
target_include_directories(
  _initialize_cpp PRIVATE ${RF_BASE_DIR}/rapidfuzz
                          ${RF_BASE_DIR}/rapidfuzz/distance)
target_link_libraries(_initialize_cpp PRIVATE rapidfuzz::rapidfuzz)
install(TARGETS _initialize_cpp LIBRARY DESTINATION src/rapidfuzz/distance)

create_cython_target(metrics_cpp)
rf_add_library(metrics_cpp ${metrics_cpp})
target_compile_features(metrics_cpp PUBLIC cxx_std_17)
target_include_directories(
  metrics_cpp PRIVATE ${RF_BASE_DIR}/rapidfuzz
                      ${RF_BASE_DIR}/rapidfuzz/distance)
target_link_libraries(metrics_cpp PRIVATE rapidfuzz::rapidfuzz)
install(TARGETS metrics_cpp LIBRARY DESTINATION src/rapidfuzz/distance)

if(RAPIDFUZZ_ARCH_X64 OR RAPIDFUZZ_ARCH_X86)
  create_cython_target(metrics_cpp_avx2)
  rf_add_library(metrics_cpp_avx2 ${metrics_cpp_avx2})
  target_compile_features(metrics_cpp_avx2 PUBLIC cxx_std_17)

  if(MSVC)
    set_target_properties(metrics_cpp_avx2 PROPERTIES COMPILE_FLAGS
                                                      "/arch:AVX2")
  else()
    set_target_properties(metrics_cpp_avx2 PROPERTIES COMPILE_FLAGS "-mavx2")
  endif()

  target_include_directories(
    metrics_cpp_avx2 PRIVATE ${RF_BASE_DIR}/rapidfuzz
                             ${RF_BASE_DIR}/rapidfuzz/distance)
  target_link_libraries(metrics_cpp_avx2 PRIVATE rapidfuzz::rapidfuzz)
  install(TARGETS metrics_cpp_avx2 LIBRARY DESTINATION src/rapidfuzz/distance)
endif()

if(RAPIDFUZZ_ARCH_X86)
  create_cython_target(metrics_cpp_sse2)
  rf_add_library(metrics_cpp_sse2 ${metrics_cpp_sse2})
  target_compile_features(metrics_cpp_sse2 PUBLIC cxx_std_17)

  if(MSVC)
    set_target_properties(metrics_cpp_sse2 PROPERTIES COMPILE_FLAGS
                                                      "/arch:SSE2")
  else()
    set_target_properties(metrics_cpp_sse2 PROPERTIES COMPILE_FLAGS "-msse2")
  endif()

  target_include_directories(
    metrics_cpp_sse2 PRIVATE ${RF_BASE_DIR}/rapidfuzz
                             ${RF_BASE_DIR}/rapidfuzz/distance)
  target_link_libraries(metrics_cpp_sse2 PRIVATE rapidfuzz::rapidfuzz)
  install(TARGETS metrics_cpp_sse2 LIBRARY DESTINATION src/rapidfuzz/distance)
endif()

=== debian/changelog ===
rapidfuzz (3.6.2+ds-1) unstable; urgency=low

  * Initial release (closes: #1019435)

 -- Julian Gilbey <jdg@debian.org>  Wed, 06 Mar 2024 09:29:57 +0000

=== debian/control ===
Source: rapidfuzz
Section: python
Priority: optional
Maintainer: Julian Gilbey <jdg@debian.org>
Build-Depends: debhelper-compat (= 13),
               dh-sequence-python3
Build-Depends-Arch: cython3,
                    librapidfuzz-cpp-dev,
                    libtaskflow-cpp-dev,
                    pybuild-plugin-pyproject,
                    python3-all-dev,
                    python3-hypothesis <!nocheck>,
                    python3-numpy <!nocheck>,
                    python3-pandas <!nocheck>,
                    python3-pytest <!nocheck>,
                    python3-setuptools,
                    python3-skbuild
Build-Depends-Indep: dh-sequence-sphinxdoc <!nodoc>,
                     furo <!nodoc>,
                     python3-sphinx <!nodoc>,
                     python3-sphinxcontrib.bibtex <!nodoc>
Standards-Version: 4.6.2
Testsuite: autopkgtest-pkg-python
Homepage: https://github.com/maxbachmann/RapidFuzz
Vcs-Browser: https://salsa.debian.org/python-team/packages/rapidfuzz
Vcs-Git: https://salsa.debian.org/python-team/packages/rapidfuzz.git
Rules-Requires-Root: no
Description: Rapid fuzzy string matching library
 RapidFuzz is a fast string matching library for Python and C++,
 providing Levenshtein and other distances.  This is similar to the
 functionality of the python3-fuzzywuzzy package.  There are a few
 significant differences between these packages:
 .
 1) RapidFuzz is MIT licensed.
 2) RapidFuzz provides many string metrics, such as Hamming and Jaro-Winkler,
    which are not included in FuzzyWuzzy.
 3) RapidFuzz is mostly written in C++, and has further algorithmic
    improvements to make string matching even faster.
 4) RapidFuzz fixes multiple bugs in the `partial_ratio` implementation.

Package: python3-rapidfuzz
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends},
         ${python3:Depends},
         ${shlibs:Depends}
Recommends: ${python3:Recommends}
Suggests: ${python3:Suggests}
Description: ${source:Synopsis} (Python library)
 ${source:Extended-Description}

Package: python-rapidfuzz-doc
Section: doc
Architecture: all
Depends: ${misc:Depends},
         ${sphinxdoc:Depends}
Recommends: python3-rapidfuzz
Description: ${source:Synopsis} (Python module documentation)
 ${source:Extended-Description}
 .
 This package contains the RapidFuzz Python module documentation in
 HTML format.
Build-Profiles: <!nodoc>

=== debian/rules ===
#! /usr/bin/make -f

export PYBUILD_NAME=rapidfuzz
export PYBUILD_TEST_PYTEST=1

SPHINXBUILD=sphinx-build
SPHINXBUILDDIR=build

%:
	dh $@ --buildsystem=pybuild

override_dh_auto_configure:
	mkdir -p buildlib
	cd buildlib && cmake ../ \
	    -D CMAKE_MODULE_PATH=/usr/lib/python3/dist-packages/skbuild/resources/cmake

ifeq (,$(findstring nodoc,$(DEB_BUILD_OPTIONS)))
execute_after_dh_auto_build-indep:
	export PYTHONPATH=$$(pybuild --print build_dir | grep "^$$(py3versions -d)" | sed -e 's/^.*: //'); \
	    cd docs && $(SPHINXBUILD) -b html -d $(SPHINXBUILDDIR)/doctrees . $(SPHINXBUILDDIR)/html

execute_after_dh_auto_clean:
	cd docs && rm -rf $(SPHINXBUILDDIR)
	rm -rf buildlib _skbuild

override_dh_installdocs:
	dh_installdocs -ppython-rapidfuzz-doc --doc-main-package=python3-rapidfuzz
	dh_installdocs --remaining-packages
endif

## rapidfuzz 3.9.4+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.12...3.24)
+cmake_minimum_required(VERSION 3.12...3.29)
 
 set(CMAKE_INTERPROCEDURAL_OPTIMIZATION TRUE)
 set(CMAKE_POSITION_INDEPENDENT_CODE ON)
@@ -73,7 +73,19 @@
 
 set(RF_BASE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/src)
 
-find_package(Taskflow 3.3.0 QUIET)
+find_package(Taskflow 3.7.0 QUIET)
+if(NOT Taskflow_FOUND)
+  find_package(Taskflow 3.6.0 QUIET)
+endif()
+if(NOT Taskflow_FOUND)
+  find_package(Taskflow 3.5.0 QUIET)
+endif()
+if(NOT Taskflow_FOUND)
+  find_package(Taskflow 3.4.0 QUIET)
+endif()
+if(NOT Taskflow_FOUND)
+  find_package(Taskflow 3.3.0 QUIET)
+endif()
 if(Taskflow_FOUND)
   message(STATUS "Using system supplied version of Taskflow")
 else()
@@ -91,7 +103,7 @@
   add_library(Taskflow::Taskflow ALIAS Taskflow)
 endif()
 
-find_package(rapidfuzz 3.0.2 QUIET)
+find_package(rapidfuzz 3.0.5 QUIET)
 if(rapidfuzz_FOUND)
   message(STATUS "Using system supplied version of rapidfuzz-cpp")
 else()

=== src/rapidfuzz/CMakeLists.txt ===
--- 
+++ 
@@ -57,19 +57,22 @@
 install(TARGETS fuzz_cpp LIBRARY DESTINATION src/rapidfuzz)
 
 if(RAPIDFUZZ_ARCH_X64 OR RAPIDFUZZ_ARCH_X86)
-  create_cython_target(fuzz_cpp_avx2)
-  rf_add_library(fuzz_cpp_avx2 ${fuzz_cpp_avx2})
-  target_compile_features(fuzz_cpp_avx2 PUBLIC cxx_std_17)
+  # on macOs this generates illegal instructions https://github.com/rapidfuzz/RapidFuzz/issues/383
+  if(NOT APPLE)
+    create_cython_target(fuzz_cpp_avx2)
+    rf_add_library(fuzz_cpp_avx2 ${fuzz_cpp_avx2})
+    target_compile_features(fuzz_cpp_avx2 PUBLIC cxx_std_17)
 
-  if(MSVC)
-    set_target_properties(fuzz_cpp_avx2 PROPERTIES COMPILE_FLAGS "/arch:AVX2")
-  else()
-    set_target_properties(fuzz_cpp_avx2 PROPERTIES COMPILE_FLAGS "-mavx2")
+    if(MSVC)
+      set_target_properties(fuzz_cpp_avx2 PROPERTIES COMPILE_FLAGS "/arch:AVX2")
+    else()
+      set_target_properties(fuzz_cpp_avx2 PROPERTIES COMPILE_FLAGS "-mavx2")
+    endif()
+
+    target_include_directories(fuzz_cpp_avx2 PRIVATE ${RF_BASE_DIR}/rapidfuzz)
+    target_link_libraries(fuzz_cpp_avx2 PRIVATE rapidfuzz::rapidfuzz)
+    install(TARGETS fuzz_cpp_avx2 LIBRARY DESTINATION src/rapidfuzz)
   endif()
-
-  target_include_directories(fuzz_cpp_avx2 PRIVATE ${RF_BASE_DIR}/rapidfuzz)
-  target_link_libraries(fuzz_cpp_avx2 PRIVATE rapidfuzz::rapidfuzz)
-  install(TARGETS fuzz_cpp_avx2 LIBRARY DESTINATION src/rapidfuzz)
 endif()
 
 if(RAPIDFUZZ_ARCH_X86)

=== src/rapidfuzz/distance/CMakeLists.txt ===
--- 
+++ 
@@ -51,22 +51,25 @@
 install(TARGETS metrics_cpp LIBRARY DESTINATION src/rapidfuzz/distance)
 
 if(RAPIDFUZZ_ARCH_X64 OR RAPIDFUZZ_ARCH_X86)
-  create_cython_target(metrics_cpp_avx2)
-  rf_add_library(metrics_cpp_avx2 ${metrics_cpp_avx2})
-  target_compile_features(metrics_cpp_avx2 PUBLIC cxx_std_17)
+  # on macOs this generates illegal instructions https://github.com/rapidfuzz/RapidFuzz/issues/383
+  if(NOT APPLE)
+    create_cython_target(metrics_cpp_avx2)
+    rf_add_library(metrics_cpp_avx2 ${metrics_cpp_avx2})
+    target_compile_features(metrics_cpp_avx2 PUBLIC cxx_std_17)
 
-  if(MSVC)
-    set_target_properties(metrics_cpp_avx2 PROPERTIES COMPILE_FLAGS
-                                                      "/arch:AVX2")
-  else()
-    set_target_properties(metrics_cpp_avx2 PROPERTIES COMPILE_FLAGS "-mavx2")
+    if(MSVC)
+      set_target_properties(metrics_cpp_avx2 PROPERTIES COMPILE_FLAGS
+                                                        "/arch:AVX2")
+    else()
+      set_target_properties(metrics_cpp_avx2 PROPERTIES COMPILE_FLAGS "-mavx2")
+    endif()
+
+    target_include_directories(
+      metrics_cpp_avx2 PRIVATE ${RF_BASE_DIR}/rapidfuzz
+                              ${RF_BASE_DIR}/rapidfuzz/distance)
+    target_link_libraries(metrics_cpp_avx2 PRIVATE rapidfuzz::rapidfuzz)
+    install(TARGETS metrics_cpp_avx2 LIBRARY DESTINATION src/rapidfuzz/distance)
   endif()
-
-  target_include_directories(
-    metrics_cpp_avx2 PRIVATE ${RF_BASE_DIR}/rapidfuzz
-                             ${RF_BASE_DIR}/rapidfuzz/distance)
-  target_link_libraries(metrics_cpp_avx2 PRIVATE rapidfuzz::rapidfuzz)
-  install(TARGETS metrics_cpp_avx2 LIBRARY DESTINATION src/rapidfuzz/distance)
 endif()
 
 if(RAPIDFUZZ_ARCH_X86)

=== debian/changelog ===
rapidfuzz (3.9.4+ds-1) unstable; urgency=medium

  * New upstream version

 -- Julian Gilbey <jdg@debian.org>  Sun, 14 Jul 2024 07:23:32 +0100

rapidfuzz (3.6.2+ds-3) unstable; urgency=medium

  * Fix arch-all build; we need to build the package to build the
    documentation (closes: #1069624)

 -- Julian Gilbey <jdg@debian.org>  Thu, 25 Apr 2024 21:02:09 +0100

rapidfuzz (3.6.2+ds-2) unstable; urgency=medium

  * Source-only upload

 -- Julian Gilbey <jdg@debian.org>  Thu, 18 Apr 2024 21:43:54 +0100

=== debian/control ===
--- 
+++ 
@@ -2,25 +2,24 @@
 Section: python
 Priority: optional
 Maintainer: Julian Gilbey <jdg@debian.org>
-Build-Depends: debhelper-compat (= 13),
-               dh-sequence-python3
-Build-Depends-Arch: cython3,
-                    librapidfuzz-cpp-dev,
-                    libtaskflow-cpp-dev,
-                    pybuild-plugin-pyproject,
-                    python3-all-dev,
-                    python3-hypothesis <!nocheck>,
+Build-Depends: cython3,
+               debhelper-compat (= 13),
+               dh-sequence-python3,
+               librapidfuzz-cpp-dev (>= 3.0.5),
+               libtaskflow-cpp-dev,
+               pybuild-plugin-pyproject,
+               python3-all-dev,
+               python3-setuptools,
+               python3-skbuild
+Build-Depends-Arch: python3-hypothesis <!nocheck>,
                     python3-numpy <!nocheck>,
                     python3-pandas <!nocheck>,
-                    python3-pytest <!nocheck>,
-                    python3-setuptools,
-                    python3-skbuild
+                    python3-pytest <!nocheck>
 Build-Depends-Indep: dh-sequence-sphinxdoc <!nodoc>,
                      furo <!nodoc>,
                      python3-sphinx <!nodoc>,
                      python3-sphinxcontrib.bibtex <!nodoc>
-Standards-Version: 4.6.2
-Testsuite: autopkgtest-pkg-python
+Standards-Version: 4.7.0
 Homepage: https://github.com/maxbachmann/RapidFuzz
 Vcs-Browser: https://salsa.debian.org/python-team/packages/rapidfuzz
 Vcs-Git: https://salsa.debian.org/python-team/packages/rapidfuzz.git
@@ -45,13 +44,15 @@
          ${python3:Depends},
          ${shlibs:Depends}
 Recommends: ${python3:Recommends}
-Suggests: ${python3:Suggests}
+Suggests: python-rapidfuzz-doc,
+          ${python3:Suggests}
 Description: ${source:Synopsis} (Python library)
  ${source:Extended-Description}
 
 Package: python-rapidfuzz-doc
 Section: doc
 Architecture: all
+Multi-Arch: foreign
 Depends: ${misc:Depends},
          ${sphinxdoc:Depends}
 Recommends: python3-rapidfuzz

=== debian/tests/control ===
Tests: pytest
Depends: python3-all,
         python3-hypothesis,
         python3-numpy,
         python3-pandas,
         python3-pytest,
         python3-rapidfuzz

## rapidfuzz 3.10.1+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,4 +1,4 @@
-cmake_minimum_required(VERSION 3.12...3.29)
+cmake_minimum_required(VERSION 3.15...3.30)
 
 set(CMAKE_INTERPROCEDURAL_OPTIMIZATION TRUE)
 set(CMAKE_POSITION_INDEPENDENT_CODE ON)
@@ -29,6 +29,10 @@
 
 if(MSVC)
   add_compile_options(/W4 /bigobj /wd4127)
+
+  # NOTE: _DISABLE_CONSTEXPR_MUTEX_CONSTRUCTOR is temporary. When building on
+  # VS 2022 17.10 or newer, but using an older runtime, mutexes can crash
+  add_compile_options(/D_DISABLE_CONSTEXPR_MUTEX_CONSTRUCTOR)
 else()
   add_compile_options(-Wall -Wextra -pedantic -Wno-psabi)
 endif()
@@ -73,7 +77,10 @@
 
 set(RF_BASE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/src)
 
-find_package(Taskflow 3.7.0 QUIET)
+find_package(Taskflow 3.8.0 QUIET)
+if(NOT Taskflow_FOUND)
+  find_package(Taskflow 3.7.0 QUIET)
+endif()
 if(NOT Taskflow_FOUND)
   find_package(Taskflow 3.6.0 QUIET)
 endif()
@@ -103,7 +110,7 @@
   add_library(Taskflow::Taskflow ALIAS Taskflow)
 endif()
 
-find_package(rapidfuzz 3.0.5 QUIET)
+find_package(rapidfuzz 3.1.1 QUIET)
 if(rapidfuzz_FOUND)
   message(STATUS "Using system supplied version of rapidfuzz-cpp")
 else()

=== debian/changelog ===
rapidfuzz (3.10.1+ds-1) unstable; urgency=medium

  * New upstream version (closes: #1087646)
  * Change maintainer to Debian Python Team with me as Uploader (always my
    intention, but somehow didn't do it when I first packaged it)

 -- Julian Gilbey <jdg@debian.org>  Tue, 19 Nov 2024 07:13:06 +0000

## rapidfuzz 3.12.1%2Bds

=== src/rapidfuzz/distance/CMakeLists.txt ===
--- 
+++ 
@@ -4,14 +4,17 @@
         ${CMAKE_CURRENT_LIST_DIR}/${_name}.cxx
         PARENT_SCOPE)
   else()
-    find_package(Cython REQUIRED)
-    # should use target_include_directories once this is supported by
-    # scikit-build
-    include_directories(${RF_BASE_DIR}/rapidfuzz
-                        ${RF_BASE_DIR}/rapidfuzz/distance)
-    add_cython_target(${_name} CXX)
+    add_custom_command(
+      OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/${_name}.cxx"
+      MAIN_DEPENDENCY "${CMAKE_CURRENT_LIST_DIR}/${_name}.pyx"
+      VERBATIM
+      COMMAND
+        Python::Interpreter -m cython "${CMAKE_CURRENT_LIST_DIR}/${_name}.pyx"
+        --cplus -I "${CMAKE_CURRENT_LIST_DIR}/.." --output-file
+        "${CMAKE_CURRENT_BINARY_DIR}/${_name}.cxx")
+
     set(${_name}
-        ${_name}
+        ${CMAKE_CURRENT_BINARY_DIR}/${_name}.cxx
         PARENT_SCOPE)
   endif()
 endfunction(create_cython_target)
@@ -39,7 +42,7 @@
   _initialize_cpp PRIVATE ${RF_BASE_DIR}/rapidfuzz
                           ${RF_BASE_DIR}/rapidfuzz/distance)
 target_link_libraries(_initialize_cpp PRIVATE rapidfuzz::rapidfuzz)
-install(TARGETS _initialize_cpp LIBRARY DESTINATION src/rapidfuzz/distance)
+install(TARGETS _initialize_cpp DESTINATION rapidfuzz/distance)
 
 create_cython_target(metrics_cpp)
 rf_add_library(metrics_cpp ${metrics_cpp})
@@ -48,10 +51,11 @@
   metrics_cpp PRIVATE ${RF_BASE_DIR}/rapidfuzz
                       ${RF_BASE_DIR}/rapidfuzz/distance)
 target_link_libraries(metrics_cpp PRIVATE rapidfuzz::rapidfuzz)
-install(TARGETS metrics_cpp LIBRARY DESTINATION src/rapidfuzz/distance)
+install(TARGETS metrics_cpp DESTINATION rapidfuzz/distance)
 
 if(RAPIDFUZZ_ARCH_X64 OR RAPIDFUZZ_ARCH_X86)
-  # on macOs this generates illegal instructions https://github.com/rapidfuzz/RapidFuzz/issues/383
+  # on macOs this generates illegal instructions
+  # https://github.com/rapidfuzz/RapidFuzz/issues/383
   if(NOT APPLE)
     create_cython_target(metrics_cpp_avx2)
     rf_add_library(metrics_cpp_avx2 ${metrics_cpp_avx2})
@@ -66,9 +70,9 @@
 
     target_include_directories(
       metrics_cpp_avx2 PRIVATE ${RF_BASE_DIR}/rapidfuzz
-                              ${RF_BASE_DIR}/rapidfuzz/distance)
+                               ${RF_BASE_DIR}/rapidfuzz/distance)
     target_link_libraries(metrics_cpp_avx2 PRIVATE rapidfuzz::rapidfuzz)
-    install(TARGETS metrics_cpp_avx2 LIBRARY DESTINATION src/rapidfuzz/distance)
+    install(TARGETS metrics_cpp_avx2 DESTINATION rapidfuzz/distance)
   endif()
 endif()
 
@@ -88,5 +92,5 @@
     metrics_cpp_sse2 PRIVATE ${RF_BASE_DIR}/rapidfuzz
                              ${RF_BASE_DIR}/rapidfuzz/distance)
   target_link_libraries(metrics_cpp_sse2 PRIVATE rapidfuzz::rapidfuzz)
-  install(TARGETS metrics_cpp_sse2 LIBRARY DESTINATION src/rapidfuzz/distance)
+  install(TARGETS metrics_cpp_sse2 DESTINATION rapidfuzz/distance)
 endif()

## rapidfuzz 3.12.1+ds

=== CMakeLists.txt ===
--- 
+++ 
@@ -30,11 +30,16 @@
 if(MSVC)
   add_compile_options(/W4 /bigobj /wd4127)
 
-  # NOTE: _DISABLE_CONSTEXPR_MUTEX_CONSTRUCTOR is temporary. When building on
-  # VS 2022 17.10 or newer, but using an older runtime, mutexes can crash
+  # NOTE: _DISABLE_CONSTEXPR_MUTEX_CONSTRUCTOR is temporary. When building on VS
+  # 2022 17.10 or newer, but using an older runtime, mutexes can crash
   add_compile_options(/D_DISABLE_CONSTEXPR_MUTEX_CONSTRUCTOR)
 else()
   add_compile_options(-Wall -Wextra -pedantic -Wno-psabi)
+endif()
+
+if(EMSCRIPTEN)
+  add_compile_options(-fexceptions)
+  add_link_options(-fexceptions)
 endif()
 
 if(CMAKE_VERSION VERSION_LESS 3.18)
@@ -77,7 +82,10 @@
 
 set(RF_BASE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/src)
 
-find_package(Taskflow 3.8.0 QUIET)
+find_package(Taskflow 3.9.0 QUIET)
+if(NOT Taskflow_FOUND)
+  find_package(Taskflow 3.8.0 QUIET)
+endif()
 if(NOT Taskflow_FOUND)
   find_package(Taskflow 3.7.0 QUIET)
 endif()
@@ -110,7 +118,7 @@
   add_library(Taskflow::Taskflow ALIAS Taskflow)
 endif()
 
-find_package(rapidfuzz 3.1.1 QUIET)
+find_package(rapidfuzz 3.2.0 QUIET)
 if(rapidfuzz_FOUND)
   message(STATUS "Using system supplied version of rapidfuzz-cpp")
 else()

=== debian/changelog ===
rapidfuzz (3.12.1+ds-1build1) plucky; urgency=medium

  * No-change rebuild with Python 3.13 only

 -- Graham Inggs <ginggs@ubuntu.com>  Tue, 04 Mar 2025 19:34:38 +0000

rapidfuzz (3.12.1+ds-1) unstable; urgency=medium

  * New upstream version

 -- Julian Gilbey <jdg@debian.org>  Mon, 03 Feb 2025 06:37:14 +0000

=== debian/control ===
--- 
+++ 
@@ -1,16 +1,17 @@
 Source: rapidfuzz
 Section: python
 Priority: optional
-Maintainer: Julian Gilbey <jdg@debian.org>
-Build-Depends: cython3,
+Maintainer: Debian Python Team <team+python@tracker.debian.org>
+Uploaders: Julian Gilbey <jdg@debian.org>
+Build-Depends: cmake,
+               cython3,
                debhelper-compat (= 13),
                dh-sequence-python3,
-               librapidfuzz-cpp-dev (>= 3.0.5),
+               librapidfuzz-cpp-dev (>= 3.1.1),
                libtaskflow-cpp-dev,
                pybuild-plugin-pyproject,
                python3-all-dev,
-               python3-setuptools,
-               python3-skbuild
+               python3-scikit-build-core
 Build-Depends-Arch: python3-hypothesis <!nocheck>,
                     python3-numpy <!nocheck>,
                     python3-pandas <!nocheck>,
@@ -43,7 +44,7 @@
 Depends: ${misc:Depends},
          ${python3:Depends},
          ${shlibs:Depends}
-Recommends: ${python3:Recommends}
+Recommends: ${python3:Recommends}, python3-numpy
 Suggests: python-rapidfuzz-doc,
           ${python3:Suggests}
 Description: ${source:Synopsis} (Python library)

## rapidfuzz 3.12.2+ds

=== src/rapidfuzz/CMakeLists.txt ===
--- 
+++ 
@@ -4,13 +4,17 @@
         ${CMAKE_CURRENT_LIST_DIR}/${_name}.cxx
         PARENT_SCOPE)
   else()
-    find_package(Cython REQUIRED)
-    # should use target_include_directories once this is supported by
-    # scikit-build
-    include_directories(${RF_BASE_DIR}/rapidfuzz)
-    add_cython_target(${_name} CXX)
+    add_custom_command(
+      OUTPUT "${CMAKE_CURRENT_BINARY_DIR}/${_name}.cxx"
+      MAIN_DEPENDENCY "${CMAKE_CURRENT_LIST_DIR}/${_name}.pyx"
+      VERBATIM
+      COMMAND
+        Python::Interpreter -m cython "${CMAKE_CURRENT_LIST_DIR}/${_name}.pyx"
+        --cplus -I "${CMAKE_CURRENT_LIST_DIR}" --output-file
+        "${CMAKE_CURRENT_BINARY_DIR}/${_name}.cxx")
+
     set(${_name}
-        ${_name}
+        ${CMAKE_CURRENT_BINARY_DIR}/${_name}.cxx
         PARENT_SCOPE)
   endif()
 endfunction(create_cython_target)
@@ -39,7 +43,7 @@
   target_include_directories(_feature_detector_cpp
                              PRIVATE ${RF_BASE_DIR}/rapidfuzz)
   target_link_libraries(_feature_detector_cpp PRIVATE rapidfuzz::rapidfuzz)
-  install(TARGETS _feature_detector_cpp LIBRARY DESTINATION src/rapidfuzz)
+  install(TARGETS _feature_detector_cpp DESTINATION rapidfuzz)
 endif()
 
 create_cython_target(utils_cpp)
@@ -47,17 +51,18 @@
 target_compile_features(utils_cpp PUBLIC cxx_std_17)
 target_include_directories(utils_cpp PRIVATE ${RF_BASE_DIR}/rapidfuzz)
 target_link_libraries(utils_cpp PRIVATE rapidfuzz::rapidfuzz)
-install(TARGETS utils_cpp LIBRARY DESTINATION src/rapidfuzz)
+install(TARGETS utils_cpp DESTINATION rapidfuzz)
 
 create_cython_target(fuzz_cpp)
 rf_add_library(fuzz_cpp ${fuzz_cpp})
 target_compile_features(fuzz_cpp PUBLIC cxx_std_17)
 target_include_directories(fuzz_cpp PRIVATE ${RF_BASE_DIR}/rapidfuzz)
 target_link_libraries(fuzz_cpp PRIVATE rapidfuzz::rapidfuzz)
-install(TARGETS fuzz_cpp LIBRARY DESTINATION src/rapidfuzz)
+install(TARGETS fuzz_cpp DESTINATION rapidfuzz)
 
 if(RAPIDFUZZ_ARCH_X64 OR RAPIDFUZZ_ARCH_X86)
-  # on macOs this generates illegal instructions https://github.com/rapidfuzz/RapidFuzz/issues/383
+  # on macOs this generates illegal instructions
+  # https://github.com/rapidfuzz/RapidFuzz/issues/383
   if(NOT APPLE)
     create_cython_target(fuzz_cpp_avx2)
     rf_add_library(fuzz_cpp_avx2 ${fuzz_cpp_avx2})
@@ -71,7 +76,7 @@
 
     target_include_directories(fuzz_cpp_avx2 PRIVATE ${RF_BASE_DIR}/rapidfuzz)
     target_link_libraries(fuzz_cpp_avx2 PRIVATE rapidfuzz::rapidfuzz)
-    install(TARGETS fuzz_cpp_avx2 LIBRARY DESTINATION src/rapidfuzz)
+    install(TARGETS fuzz_cpp_avx2 DESTINATION rapidfuzz)
   endif()
 endif()
 
@@ -88,7 +93,7 @@
 
   target_include_directories(fuzz_cpp_sse2 PRIVATE ${RF_BASE_DIR}/rapidfuzz)
   target_link_libraries(fuzz_cpp_sse2 PRIVATE rapidfuzz::rapidfuzz)
-  install(TARGETS fuzz_cpp_sse2 LIBRARY DESTINATION src/rapidfuzz)
+  install(TARGETS fuzz_cpp_sse2 DESTINATION rapidfuzz)
 endif()
 
 create_cython_target(process_cpp_impl)
@@ -184,4 +189,4 @@
   endif()
 endif()
 
-install(TARGETS process_cpp_impl LIBRARY DESTINATION src/rapidfuzz)
+install(TARGETS process_cpp_impl DESTINATION rapidfuzz)

=== debian/changelog ===
rapidfuzz (3.12.2+ds-1build1) resolute; urgency=medium

  * No-change rebuild with Python 3.14 as supported version

 -- Graham Inggs <ginggs@ubuntu.com>  Mon, 20 Oct 2025 15:00:49 +0000

rapidfuzz (3.12.2+ds-1) unstable; urgency=medium

  * New upstream version
  * Ignore Cython dependency version bump; it is not yet packaged

 -- Julian Gilbey <jdg@debian.org>  Tue, 01 Apr 2025 12:41:41 +0100

=== debian/rules ===
--- 
+++ 
@@ -14,16 +14,20 @@
 	cd buildlib && cmake ../ \
 	    -D CMAKE_MODULE_PATH=/usr/lib/python3/dist-packages/skbuild/resources/cmake
 
+execute_after_dh_auto_build-indep:
+	: # ensure that this target is non-empty
 ifeq (,$(findstring nodoc,$(DEB_BUILD_OPTIONS)))
-execute_after_dh_auto_build-indep:
 	export PYTHONPATH=$$(pybuild --print build_dir | grep "^$$(py3versions -d)" | sed -e 's/^.*: //'); \
 	    cd docs && $(SPHINXBUILD) -b html -d $(SPHINXBUILDDIR)/doctrees . $(SPHINXBUILDDIR)/html
+endif
+
+override_dh_auto_test-indep:
+	# No need to run tests when only building documentation package
 
 execute_after_dh_auto_clean:
-	cd docs && rm -rf $(SPHINXBUILDDIR)
+	rm -rf docs/$(SPHINXBUILDDIR)
 	rm -rf buildlib _skbuild
 
 override_dh_installdocs:
-	dh_installdocs -ppython-rapidfuzz-doc --doc-main-package=python3-rapidfuzz
+	dh_installdocs -ppython-$(PYBUILD_NAME)-doc --doc-main-package=python3-$(PYBUILD_NAME)
 	dh_installdocs --remaining-packages
-endif

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(@ANY_VERSION@@ARCHIVE_EXT@)%RapidFuzz-$1%, \
      dversionmangle=s/\+ds//, \
      repack, repacksuffix=+ds" \
    https://github.com/maxbachmann/RapidFuzz/tags \
    (?:.*?/)v?@ANY_VERSION@@ARCHIVE_EXT@
